<script setup>
    import {ref, onMounted} from 'vue'
    import { HttpReq } from '@/utilies/httpRequest';
    import SchedulePickupModal from '@/components/SchedulePickupModal.vue';

    const codeCities = ref([])
    const historyPickups = ref([])

    const refSchedulePickupModal = ref(null)

    const headers = [
        {
            text: 'Modalidad',
            align: 'start',
            value: 'modality'
        },
        {
            text: "Fecha de recogida",
            value: "pickupDate"
        },
        {
            text: "Referencia",
            value: "reference"
        },
        {
            text: "Observaciones",
            value: "observation"
        },
        {
            text: "Mensaje",
            value: "message"
        }
    ]

    const modalityData = ref([
        { modality: 'Cuenta Corriente', value: 1  },
        { modality: 'Flete Pago', value: 2  },
        { modality: 'Flete Contra Entrega', value: 3 },
        { modality: 'Flete al Cobro', value: 4 },
        { modality: 'Acuerdo Semanal', value: 5 },
        { modality: 'CC Int.', value: 6 },
        { modality: 'FPI', value: 7 },
        { modality: 'CC/INT', value: 8 },
    ])

    onMounted(() => {
        getAllPickups()
        getCities()
    })

    function openModalSchedulePickup() {
        refSchedulePickupModal.value.openModal()
    }

    async function getCities() {
        let resp = await HttpReq.getData('soap/cities');

        if(resp.status == 200) {
            codeCities.value = resp.data
        } else {
            console.log("error")
        }

    }

    async function getAllPickups() {
        let resp = await HttpReq.getData('pickup')
        if(resp.status == 200) {
            if(Array.isArray(resp.data))
                if(resp.data.length > 0)
                    historyPickups.value = resp.data.map(item => {
                        return {
                            modality: modalityData.value.find(modality => modality.value == item.modality).modality,
                            pickupDate: item.pickupDate,
                            reference: item.reference,
                            observation: item.observation,
                            message: item.pickupOutput ? item.pickupOutput.message : "" 
                        }
                    })
        } else {
            console.log("error")
        }
    }

    function newPickup(data) {
        historyPickups.value.push({
            modality: modalityData.value.find(modality => modality.value == data.modality).modality,
            pickupDate: data.pickupDate,
            reference: data.reference,
            observation: data.observation,
            message: data.pickupOutput ? data.pickupOutput.message : "" 
        })
    }

</script>

<template>

    <div class="mb-10 pb-10">

        <!--Modals or Dialogs-->
        <SchedulePickupModal ref="refSchedulePickupModal" :codeCities="codeCities" :modalityData="modalityData" @newPickup="newPickup" />

        <v-row>
            <v-col cols="12">
                <v-btn
                    @click="openModalSchedulePickup"
                >
                    Programar recogida
                    <v-icon>mdi-account-clock</v-icon>
                </v-btn>
            </v-col>
        </v-row>
        <v-row>
            <v-col cols="12">
                <v-data-table
                    :headers="headers"
                    :items="historyPickups"
                    :disable-sort="false"
                >

                </v-data-table>
            </v-col>
        </v-row>
    </div>

</template>

<style>

</style>